//preamble 









#include "project.h"
#include <stdio.h>
void start_uart();
void InitializeWDT(void);

int main(void)
{
    __enable_irq(); /* Enable global interrupts. */
    start_uart();
    InitializeWDT();
    printf("hello new project 2\n");
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */

    for(;;)
    {
        /* Place your application code here. */
        printf("line %i wd count: %u SRSS_WDT_CTL: %08X\n", __LINE__ , (unsigned int)Cy_WDT_GetCount(), (unsigned int)SRSS_WDT_CTL);   
        CyDelay(500);
    }
}

void start_uart()
{
 cy_en_sysint_status_t sysint_status = CY_SYSINT_BAD_PARAM;

    sysint_status = Cy_SysInt_Init(&UART_HOST_SCB_IRQ_cfg, &UART_HOST_Interrupt);             //this sets up the interrupt for the output UART
    if(sysint_status != CY_SYSINT_SUCCESS)
    {
    	//printf("error Cy_SysInt_Init UART_HOST_SCB_IRQ_cfg \r\n");
    	//handle_error_init_peripherals();
		//critical_error("init_UARTS  Cy_SysInt_Init(&UART_HOST_SCB_IRQ_cfg, &UART_HOST_Interrupt)", DONT_SKIP_COUNT, DONT_SKIP_SLAVE);
        while(1);
    }
    NVIC_EnableIRQ((IRQn_Type) UART_HOST_SCB_IRQ_cfg.intrSrc);
   
    cy_en_scb_uart_status_t sts = Cy_SCB_UART_Init(UART_HOST_HW, &UART_HOST_config, &UART_HOST_context);
    if(sts!= CY_SCB_UART_SUCCESS)
    {
        while(1);
    	//critical_error("init_UARTS  Cy_SCB_UART_Init(UART_HOST_HW, &UART_HOST_config, &UART_HOST_context)", DONT_SKIP_COUNT, DONT_SKIP_SLAVE);
    }
    Cy_SCB_UART_Enable(UART_HOST_HW);
    Cy_SCB_UART_Put(UART_HOST_HW, '1');   
}
void InitializeWDT()
{
	 /* Step 1- Unlock WDT */
	Cy_WDT_Unlock();
    printf("line %i wd count: %u SRSS_WDT_CTL: %08X\n", __LINE__ , (unsigned int)Cy_WDT_GetCount(), (unsigned int)SRSS_WDT_CTL);   
	/* Step 2- Write the ignore bits - operate with full 16 bits */
	Cy_WDT_SetIgnoreBits(0); //higher number -> faster the reset occurrs 
    printf("line %i wd count: %u SRSS_WDT_CTL: %08X\n", __LINE__ , (unsigned int)Cy_WDT_GetCount(), (unsigned int)SRSS_WDT_CTL);   


	Cy_WDT_SetMatch(0);
    printf("line %i wd count: %u SRSS_WDT_CTL: %08X\n", __LINE__ , (unsigned int)Cy_WDT_GetCount(), (unsigned int)SRSS_WDT_CTL);   


	/* Step 4- Clear match event interrupt, if any */
	Cy_WDT_ClearInterrupt();
    printf("line %i wd count: %u SRSS_WDT_CTL: %08X\n", __LINE__ , (unsigned int)Cy_WDT_GetCount(), (unsigned int)SRSS_WDT_CTL);   

	/* Step 5- Enable ILO */
	Cy_SysClk_IloEnable();
    printf("line %i wd count: %u SRSS_WDT_CTL: %08X\n", __LINE__ , (unsigned int)Cy_WDT_GetCount(), (unsigned int)SRSS_WDT_CTL);   

	/* Step 6 - Enable interrupt if periodic interrupt mode selected */


	/* Step 7- Enable WDT */
	Cy_WDT_Enable();
    printf("line %i wd count: %u SRSS_WDT_CTL: %08X\n", __LINE__ , (unsigned int)Cy_WDT_GetCount(), (unsigned int)SRSS_WDT_CTL);   

	/* Step 8- Lock WDT configuration */
	Cy_WDT_Lock();
    printf("line %i wd count: %u SRSS_WDT_CTL: %08X\n", __LINE__ , (unsigned int)Cy_WDT_GetCount(), (unsigned int)SRSS_WDT_CTL);   
}

 // this blob allows for use of printf() with the PSoC UART    
#if defined (__GNUC__)
    /* Add an explicit reference to the floating point printf library to allow
    the usage of the floating point conversion specifier. */
    /* For the GCC compiler, revise the  _write() function for the printf functionality */
    int _write(int file, char *ptr, int len)
    {
        int nChars = 0;

        /* Suppress the compiler warning about an unused variable. */
        if (0 != file)
        {
        }
        
        for (/* Empty */; len != 0; --len)
        {
            /* Block until there is space in the TX FIFO or buffer. */
            while (0UL == Cy_SCB_UART_Put(UART_HOST_HW, *ptr))
            {
            }
            
            ++nChars;
            ++ptr;
        }
        
        return (nChars);
    }
#elif defined(__ARMCC_VERSION)
    /* For the MDK/RVDS compiler, revise the fputc() function for the printf functionality */
    struct __FILE
    {
        int handle;
    };
    
    enum
    {
        STDIN_HANDLE,
        STDOUT_HANDLE,
        STDERR_HANDLE
    };
    
    FILE __stdin = {STDIN_HANDLE};
    FILE __stdout = {STDOUT_HANDLE};
    FILE __stderr = {STDERR_HANDLE};
    
    int fputc(int ch, FILE *file)
    {
        int ret = EOF;
        switch(file->handle)
        {
            case STDOUT_HANDLE:
                while (0UL == Cy_SCB_UART_Put(UART_HOST_HW, ch))
                {
                }
                ret = ch;
            break;
                
            case STDERR_HANDLE:
                ret = ch;
            break;
                
            default:
                file = file;
            break;
        }
        return(ret);
    }
    
#elif defined (__ICCARM__)
    /* For the IAR compiler, revise the  __write() function for the printf functionality */
    size_t __write(int handle, const unsigned char * buffer, size_t size)
    {
        size_t nChars = 0;
        
        for (/* Empty */; size != 0; --size)
        {
            Cy_SCB_UART_Put(UART_HOST_HW, *buffer++);
            ++nChars;
        }
    return (nChars);
}

#endif /* (__GNUC__) */
